#!/usr/bin/env python
"""
  Podprogrammy dlq analiza FAT.
  Ispolxzowano
http://www.win.tue.nl/~aeb/linux/fs/fat/fat-1.html
-> fat3.htm .
  Nedodelki: 
- Ignoriruetsq wremq modifikacii - velatelxno ego wywoditx.
"""
from obscie import *
from geral import printable_s
from struct import *
import os,stat

# --------

def make_global(imq_):
 "Imq ustrojstwa ili obraza - dlq otlado`nyh pe`atej."
 global imq
 imq=imq_

# --------

def butsekt_common(s):
 "imq - predp. globalxnym, i ispolxz. tk. dlq otlad. pe`ati."
 global reserved_sectors, sectors_per_FAT, FAT_copies, root_entries_16
 global total_sectors_12,sectors_per_cluster
 print '\n----- butsekt_common -----\\'

 assert len(s)==512
 assert s[-2:]=='\x55\xAA'

 jump = s[:3]
 print 'jump = %02X %02X %02X' % (ord(jump[0]),ord(jump[1]),ord(jump[2]))
 if ord(jump[0])==0xEB:
  ofse = ord(s[1])   # Nedodelka - ado interpr. kak `islo so znakom !!!
  adre = 2+ofse
  print ofse,adre
 elif ord(jump[0])==0xE9:
  ofse, = unpack('H',s[1:3])
  adre = 3+ofse
  print ofse,adre
 else:
  adre = 0
 print 'adre=%02X %3d' % (adre,adre)

 name = s[3:11]
 print 'name=',repr(name)

 # Must be one of 512, 1024, 2048, 4096.
 bytes_per_sector, = unpack('H',s[0x0B:0x0D])
 print 'bytes_per_sector',bytes_per_sector
 assert bytes_per_sector in [512, 1024, 2048, 4096]
 if bytes_per_sector!=512: print 'bytes_per_sector!=512 !!!'

 # Must be one of 1, 2, 4, 8, 16, 32, 64, 128.
 sectors_per_cluster, = unpack('B',s[13])
 print 'sectors_per_cluster',sectors_per_cluster
 assert sectors_per_cluster in [1, 2, 4, 8, 16, 32, 64, 128]

 # "FAT12 and FAT16 use 1. FAT32 uses 32"; realxno - bywaet inoe! 
 reserved_sectors, = unpack('H',s[14:16])
 print 'reserved_sectors=',reserved_sectors

 FAT_copies, = unpack('B',s[16])
 print 'FAT_copies=',FAT_copies

 # 0 for FAT32. 512 is recommended for FAT16.
 root_entries, = unpack('H',s[17:19])
 print 'root_entries, root_entries_div_16 =',root_entries,root_entries/16 
 assert root_entries%16==0
 root_entries_16 = root_entries/16

 # Dlq FAT32 i bolx[ih razmerow - newerno !!!
 total_sectors_12, = unpack('H',s[19:21])
 print 'total_sectors_12, size_Mb=',total_sectors_12,total_sectors_12/2/1000.

 # F0 dlq 1.4 MB floppy etc.
 media_descriptor, = unpack('B',s[21])
 print 'media_descriptor=%02X' % (media_descriptor,) 
 
 # 9 dlq FAT12 i FAT16, 0 dlq FAT32.
 sectors_per_FAT, = unpack('H',s[22:24])
 print 'sectors_per_FAT=',sectors_per_FAT 

 sec_track,heads,hidd_secs = unpack('HHH',s[24:30]) 
 print 'sec_track,heads=',sec_track,heads
 print 'hidd_secs=',hidd_secs

 ft = '%-14s 0x%02X %-16s %3d %3d %3d %3d %3d %3d %5d %3d %5d'
 spisok = (
   imq,
   adre,
   printable_s(name), 
   bytes_per_sector,
   sectors_per_cluster,
   reserved_sectors,
   FAT_copies,
   root_entries, root_entries_16,
   total_sectors_12, 
   # media_descriptor,
   sectors_per_FAT,
   # sec_track,heads,
   hidd_secs
 )
 s = ft % spisok
 print s

 print '----- butsekt_common -----/\n'
 return(spisok,s)

def butsekt_FAT16(s):
 """
28-31   Number of hidden sectors (0)
32-35   Total number of sectors in the filesystem
        (if not given in bytes 19-20)
36      Logical Drive Number (for use with INT 13, e.g. 0 or 0x80)
37      Reserved; used by Windows NT
38      0x29 => Extended == three following fields are present.
39-42   Serial number of partition
43-53   Volume label or "NO NAME    "
54-61   Filesystem type (E.g. "FAT12   ", "FAT16   ", "FAT     ", or all zero.)
 """
 global total_sectors_16
 print '\n----- butsekt_FAT16 -----\\'

 hidd_secs_, = unpack('L',s[28:32])
 print 'hidd_secs_=',hidd_secs_
 total_sectors_16, = unpack('L',s[32:36])
 print 'total_sectors_16=',total_sectors_16
 log_nr = ord(s[36])
 reserv = ord(s[37])
 extend = ord(s[38])
 print 'extend=%02X' % (extend,)
 ser_nr, = unpack('L',s[39:43])
 vol_label = s[43:54]
 fs_type = s[54:62]

 ft =  '%-14s %7d %8d %3d %2d %2d %08X %-12s %-12s'
 spisok = (
   imq,
   hidd_secs_, total_sectors_16,
   log_nr, reserv, extend,
   ser_nr, repr(printable_s(vol_label)), repr(printable_s(fs_type))
 )
 s = ft % spisok
 print s

 print '----- butsekt_FAT16 -----/\n'
 return(spisok,s)

def butsekt_FAT32(s):
 """
28-31   Number of hidden sectors (0)
32-35   Total number of sectors in the filesystem
36-39   Sectors per FAT
40-41   Mirror flags
        Bits 0-3: number of active FAT (if bit 7 is 1)
        Bits 4-6: reserved
        Bit 7: one: single active FAT; zero: all FATs are updated at runtime
        Bits 8-15: reserved
42-43   Filesystem version
44-47   First cluster of root directory (usually 2)
48-49   Filesystem information sector number in FAT32 reserved area (usually 1)
50-51   Backup boot sector location or 0 or 0xffff if none (usually 6)
52-63   Reserved
64      Logical Drive Number (for use with INT 13, e.g. 0 or 0x80)
65      Reserved - used to be Current Head (used by Windows NT)
66      Extended signature (0x29)
        Indicates that the three following fields are present.
67-70   Serial number of partition
71-81   Volume label
82-89   Filesystem type ("FAT32   ")

  W FAT12 i FAT16 - root directory was not part of the Data Area,
and was in a known place with a known size, and hence was unable to grow.
  W FAT32 - root directory is in the Data Area.
 """
 global total_sectors_32,sectors_per_FAT_,root_dai1cluster
 print '\n----- butsekt_FAT32 -----\\'
 hidd_secs_32, = unpack('L',s[28:32])
 print 'hidd_secs_32=',hidd_secs_32
 total_sectors_32, = unpack('L',s[32:36])
 print 'total_sectors_32=',total_sectors_32
 sectors_per_FAT_, = unpack('L',s[36:40])
 print 'sectors_per_FAT_=',sectors_per_FAT_
 mirror_flags, = unpack('H',s[40:42])
 print 'mirror_flags = 0x%04X' % (mirror_flags,)
 fs_version, = unpack('H',s[42:44])
 print 'fs_version = 0x%04X' % (fs_version,)
 root_dai1cluster, = unpack('L',s[44:48])  # Usually 2.
 print 'root_dai1cluster =', root_dai1cluster  
 fs_inf_sec_nr, = unpack('H',s[48:50])     # Usually 1.
 print 'fs_inf_sec_nr =', fs_inf_sec_nr  
 backup_boot, = unpack('H',s[50:52])     # Usually 6; 0 ili FFFF -> ots.
 print 'backup_boot =', backup_boot  
 # 52-63   Reserved
 log_nr = ord(s[64])
 print 'log_nr=0x%02X' % (log_nr,)
 extend = ord(s[66])
 print 'extend=0x%02X' % (extend,)
 ser_nr, = unpack('L',s[67:71])
 vol_label = s[71:82]
 fs_type = s[82:90]

 ft =  '%-14s %7d %8d %3d %08X %-12s %-12s'
 spisok = (
   imq,
   hidd_secs_32, total_sectors_32,
   root_dai1cluster,
   ser_nr, repr(printable_s(vol_label)), repr(printable_s(fs_type))
 )
 s = ft % spisok
 print s
 
 print '----- butsekt_FAT32 -----/\n'
 return(spisok,s)

# --------

def read_butsekt():
 "~tenie butsektora." 
 f0=open(imq,'rb')
 s = f0.read(512)
 f0.close()
 assert len(s)==512
 return(s)

def read_FAT(nr_kopii=1):
 "~tenie FAT."
 global s_FAT
 print '\n----- read_FAT -----\\'
 assert nr_kopii<=FAT_copies
 n0 = reserved_sectors + (nr_kopii-1)*spF
 print 'read_FAT: n0=',n0,'%08X' % (n0*512,)
 f0=open(imq,'rb')
 f0.seek(512*n0)
 s = f0.read(512*spF)
 f0.close()
 print 'read_FAT: spF=',spF
 assert len(s)==512*spF
 s_FAT=s
 print '----- read_FAT -----/\n'
 return(s)

def read_glawn_kat_12_16():
 """
 ~tenie glawnogo kataloga w FAT12 i FAT16.
 """ 
 print '\n----- read_glawn_kat_12_16 -----\\'
 n0 = reserved_sectors + FAT_copies*spF

 print 'n0=',n0,'%08X' % (n0*512,)
 print 'root_sectors=',root_sectors

 f0=open(imq,'rb')
 f0.seek(512*n0)
 s = f0.read(512*root_sectors)
 f0.close()
 # print 'len(s)=',len(s),len(s)/512
 assert len(s)==512*root_sectors
 print '----- read_glawn_kat_12_16 -----/\n'
 return(s)

"""
def read_glawn_kat_32_():
 
 Dlq otladki - w FAT32 `itaem tolxko na`alo glawnogo kataloga !!!
 Dlq `teniq wsego glawn. kat. - nado peredelatx, i
 analizirowatx cepo`ku klasterow !!!
  
 print '\n----- read_glawn_kat_32_ -----\\'
 if root_dai1cluster!=2:
  print 'read_glawn_kat_32_: root_dai1cluster=',root_dai1cluster,'- !!!'
  return
 n1 = reserved_sectors + FAT_copies*spF
 f0=open(imq,'rb')
 f0.seek(512*n1)
 s = f0.read(512*sectors_per_cluster)  # ~itaem tk. perwyj klaster !!!
 print '~itaem tk. perwyj sektor !!!'
 print '----- read_glawn_kat_32_ -----/\n'
 return(s)
"""

def read_glawn_kat_32():
 print '\n----- read_glawn_kat_32 -----\\'
 assert tip=='FAT32'
 cep = get_cepocka(s_FAT,root_dai1cluster, otlad=True)
 print 'read_glawn_kat_32: cep=',cep
 izwl_fajl('main_dir.dat',sectors_per_cluster*512*len(cep),cep)
 main_dir = ww_fajl('main_dir.dat')
 print '----- read_glawn_kat_32 -----/\n'
 return(main_dir)

def read_glawn_kat():
 if tip in ['FAT12', 'FAT16']: s = read_glawn_kat_12_16()
 else: s = read_glawn_kat_32()
 return(s)

# --------
 
tip=None
priznaki_konca = {'FAT12':0xFFF, 'FAT16':0xFFFF, 'FAT32':0x0FFFFFFF}

def test_tip():
 """
 Microsoft operating systems use the following rule
 to distinguish between FAT12, FAT16 and FAT32.
 First, compute the number of clusters in the data area
 (by taking the total number of sectors, subtracting
 the space for reserved sectors, FATs and root directory,
 and dividing, rounding down, by the number of sectors
 in a cluster).
 If the result is less that 4085 we have FAT12.
 Otherwise, if it is less than 65525 we have FAT16.
 Otherwise FAT32.
 Problema: `toby pro`estx total number of sectors,
 nuvno uve znatx podtip fajl. s-my! 
 """
 global tip,prizn_konca
 print '\n----- test_tip -----\\'

 butsekt = read_butsekt()
 wavnejs(butsekt)

 print 'data_clusters=',data_clusters
 tip=''
 if data_clusters<4085: tip='FAT12'
 elif data_clusters<65525L: tip='FAT16'
 else: tip='FAT32'
 print 'Ovid. tip=',repr(tip)
 prizn_konca = priznaki_konca[tip] 
 print '----- test_tip -----/\n'
 return(tip)

def wavnejs(s):
 "s - \to butsektor."
 global reserved_sectors, FAT_copies, spF, root_sectors, root_dai1cluster
 global sectors_per_cluster, data_clusters 
 print '\n----- wavnejs -----\\'
 assert len(s)==512 and s[-2:]=='\x55\xAA'

 reserved_sectors, = unpack('H',s[14:16])

 FAT_copies, = unpack('B',s[16])

 sectors_per_FAT, = unpack('H',s[22:24])
 sectors_per_FAT_, = unpack('L',s[36:40])
 if sectors_per_FAT!=0: spF = sectors_per_FAT
 else:                  spF = sectors_per_FAT_

 print 'spF = %6d = %08X' % (spF,spF)

 total_sectors, = unpack('H',s[19:21])
 total_sectors_, = unpack('L',s[32:36]) 

 if total_sectors!=0: ts = total_sectors
 else:                ts = total_sectors_  

 print 'ts = %6d = %08X' % (ts,ts)
 # analiz(ts)  # Iz sobstw. primes.py; dlq disket -> krugl., ina`e - nekrugl.

 sectors_per_cluster, = unpack('B',s[13])

 root_entries, = unpack('H',s[17:19])  # Dlq FAT32 ==0.
 assert root_entries%16==0
 root_sectors = root_entries/16
 print 'root_sectors=',root_sectors

 if root_entries==0:
  root_dai1cluster, = unpack('L',s[44:48])  # Usually 2.

 n_sluvebn = reserved_sectors + FAT_copies*spF + root_sectors 
 print 'n_sluvebn=', \
   reserved_sectors,'+',FAT_copies,'*',spF,'+',root_sectors,'=',n_sluvebn
 data_sectors = ts - n_sluvebn

 ostatok = data_sectors%sectors_per_cluster
 if ostatok!=0:
  print 'data_sectors%sectors_per_cluster=',\
    data_sectors,'%',sectors_per_cluster,'=',ostatok
 data_clusters = data_sectors/sectors_per_cluster

 print 'data_clusters=',data_clusters
 
 print '----- wavnejs -----/\n'

# --------

def FAT12_i(s,i):
 """
 Tipi`noe na`alo FAT12:
 F0 FF FF 03 40 00 05 60 00 07 80 00 09 A0 00 0B C0 00 0D E0 .
 Dlq i=0 i 1 - ispolxz. bajty 0..2,
 dlq i=2 i 3 -                3..5,
 etc.
 i   = 0  1  2  3  4  5 ...
 i/2 = 0  0  1  1  2  2 ...
 j =   0  0  3  3  6  6 ...
 """
 j = (i/2)*3  # 0, 0, 3, 3, 6, 6, ...
 trojka = s[j:j+3]  # 03 40 00 etc.
 a,b,c = map(ord,trojka)
 if i%2==0: n = (b%16)*256+a  # -> 003
 else:      n =c*16+b/16      # -> 004
 return(n)

def FAT16_i(s,i):
 s_ = s[(2*i):(2*i+2)]
 # print 'FAT16_i:',i,len(s_),repr(s_)
 n, = unpack('H',s_)
 return(n)

def FAT32_i(s,i):
 s_ = s[(4*i):(4*i+4)]
 n, = unpack('L',s_)
 return(n)

def FAT_i(s,i):
 assert tip in ['FAT12', 'FAT16', 'FAT32']
 if tip=='FAT12': n = FAT12_i(s,i)
 elif tip=='FAT16': n = FAT16_i(s,i)
 elif tip=='FAT32': n = FAT32_i(s,i)
 return(n) 

# --------

def obrab(date,time):
 """
 22-23   Time (5/6/5 bits, for hour/minutes/doubleseconds)
 24-25   Date (7/4/5 bits, for year-since-1980/month/day)
 """
 day = date%(2**5)
 x = date/(2**5)
 month = x%(2**4)
 year = 1980+x/(2**4)
 # print year,month,day
 sec = (time%(2**5))*2
 x = time/(2**5)
 min = x%(2**6)
 hour = x/(2**6)
 # print hour,min,sec
 return((year,month,day), (hour,min,sec))

# --------

def anal_zapisx(s):
 """
 Analiz zapisi o fajle.
 Dann. podprog. ras`itana li[x na korotkie imena (formata 8+3).
 22-23   Time (5/6/5 bits, for hour/minutes/doubleseconds)
 24-25   Date (7/4/5 bits, for year-since-1980/month/day)
 """
 assert len(s)==32
 if ord(s[0])==0: return('unused',None,0,0,0,0,0)  # Neispolxzowannaq zapisx.
 attrib = ord(s[11])
 # print 'attrib = %02X' % (attrib,)
 if attrib==0x0F: return('longname',None,0,0,0,0,0)  # ~astx dlinnogo imeni.

 udalxnn=False
 imq0=s[:8]; imq0=imq0.rstrip()
 if imq0[0]==chr(0xE5): udalxnn=True; imq0='x'+imq0[1:]  # Udal@nnyj fajl.
 rassir=s[8:11]; rassir=rassir.rstrip()
 imq=imq0
 if rassir!='': imq = imq+'.'+rassir 

 start_clus, = unpack('H',s[26:28])
 dlina, = unpack('L',s[28:32])
 date, = unpack('H',s[24:26])
 time, = unpack('H',s[22:24])
 # print 'date,time=%04X %04X' % (date,time)
 date,time = obrab(date,time)

 if udalxnn: return('deleted',imq,attrib,start_clus,dlina,date,time)  

 return('realxn',imq,attrib,start_clus,dlina,date,time)

def katalog_i(katalog,i):
 n0 = i*32
 zapisx = katalog[n0:(n0+32)]
 tip_zapisi,imq,attrib,start_clus,dlina,date,time = anal_zapisx(zapisx)
 return(tip_zapisi,imq,attrib,start_clus,dlina,date,time)

def show_katalog(katalog, show_tipy=['realxn']):
 """
 show_tipy = ['unused', 'longname', 'deleted', 'realxn']
 """
 n = len(katalog)/32
 print 'show_katalog: n=',n
 for i in range(n):
  tip_zapisi,imq,attrib,start_clus,dlina,date,time = katalog_i(katalog,i)
  if tip_zapisi in show_tipy:
   print '%-8s %3d %-12s %02X %4d %7d %-16s %-16s' % \
     (tip_zapisi,i,printable_s(imq),attrib,start_clus,dlina,date,time)

def klast_sekt(i_klast):
 n_sluvebn = reserved_sectors + FAT_copies*spF + root_sectors 
 i_sekt = n_sluvebn + sectors_per_cluster*(i_klast-2)
 return(i_sekt)

def read_cluster(i_klast):
 i_sekt = klast_sekt(i_klast)
 f0 = open(imq,'rb')
 # print 'sectors_per_cluster=',sectors_per_cluster
 f0.seek(i_sekt*512)
 s = f0.read(sectors_per_cluster*512)
 f0.close()
 return(s)


def get_opisaniq(katalog):
 "Wydelenie opisanij fajlow."
 print '----- get_opisaniq -----\\'
 opisaniq = []
 n = len(katalog)/32
 print 'n=',n
 for i in range(n):
  xxx = katalog_i(katalog,i)
  tip_zapisi,imq,attrib,start_clus,dlina,date,time = xxx
  # ('realxn', 'NIKON001.DSC', 34, 3, 512, (2006, 1, 1), (0, 0, 0))
  # print tip_zapisi,imq,attrib,start_clus,dlina,date,time

  if tip_zapisi in ['realxn']:  # , 'deleted']:
   print '%-8s %3d %-12s %02X %4d %7d %-16s %-16s' % \
      (tip_zapisi,i,printable_s(imq),attrib,start_clus,dlina,date,time)
   opisaniq.append((imq,attrib,start_clus,dlina,date,time))
  if tip_zapisi=='unused': break
 print '----- get_opisaniq -----/'
 return(opisaniq)

def get_cepocka(s_FAT,i, otlad=True):
 "i - nomer na`alxnogo klastera."
 if otlad: print '----- get_cepocka -----\\'
 cep = []
 while True:
  cep.append(i)
  j = FAT_i(s_FAT,i)
  if otlad: print 'i,j=',i,j    
  if j == prizn_konca: break
  i=j
 # print '-> cep=',cep 
 if otlad: print '----- get_cepocka -----/'
 return(cep)

def izwl_fajl(imq1,dlina,cep):
 print '----- izwl_fajl '+imq1+'-----\\'
 dlina_klast = sectors_per_cluster*512
 if dlina==0: dlina=len(cep)*dlina_klast  # Dlq katalogow.
 procitano = 0

 f1=open(imq1,'wb')
 for i_klast in cep:
  # j = klast_sekt(i_klast)
  s =read_cluster(i_klast)
  procitano += len(s)
  if procitano>dlina:
   lisnie = procitano-dlina
   nuvnye = dlina_klast-lisnie
   s=s[:nuvnye]
  f1.write(s)
 f1.close()

 print '----- izwl_fajl '+imq1+'-----/'

# --------

if __name__=='__main__':
 ss=dir()
 for s in ss: print s
